Bug 515716 - [Broadcom 5.5 FEAT] Update bnx2x to 1.52.1-5
Summary: [Broadcom 5.5 FEAT] Update bnx2x to 1.52.1-5
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel
Version: 5.5
Hardware: All
OS: Linux
high
high
Target Milestone: rc
: 5.5
Assignee: Stanislaw Gruszka
QA Contact: Red Hat Kernel QE team
URL:
Whiteboard:
: 511975 513232 513935 516090 516979 530121 (view as bug list)
Depends On:
Blocks: 499522 533192 543126 557292 481160 496328 513912 516612 516636 517378 517380 522600 530121 533941 5.5TechNotes-Updates 620665
TreeView+ depends on / blocked
 
Reported: 2009-08-05 13:33 UTC by Eilon Greenstein
Modified: 2018-11-28 20:04 UTC (History)
25 users (show)

Fixed In Version:
Doc Type: Enhancement
Doc Text:
= Broadcom Everest network devices = The bnx2x driver for Broadcom Everest network devices has been updated to version 1.52.1-5.(BZ#515716, BZ#522600)
Clone Of:
Environment:
Last Closed: 2010-03-30 07:26:58 UTC
Target Upstream Version:


Attachments (Terms of Use)
0001-bnx2x-update-to-1.52.1.patch (486.51 KB, patch)
2009-11-12 11:30 UTC, Stanislaw Gruszka
no flags Details | Diff
0002-bnx2x-add-firmware-blob-5.0.21.0.patch (1.80 MB, patch)
2009-11-12 11:31 UTC, Stanislaw Gruszka
no flags Details | Diff
Add requied mdio functionality to bnx2x (4.78 KB, patch)
2009-11-12 12:06 UTC, Eilon Greenstein
no flags Details | Diff
0001-bnx2x-update-to-1.52.1.patch (486.07 KB, patch)
2009-11-19 15:25 UTC, Stanislaw Gruszka
no flags Details | Diff
0002-bnx2x-add-firmware-version-5.2.7.0.patch (1.80 MB, patch)
2009-11-19 15:26 UTC, Stanislaw Gruszka
no flags Details | Diff
0003-bnx2x-add-MDIO-support.patch (31.02 KB, patch)
2009-11-19 15:27 UTC, Stanislaw Gruszka
no flags Details | Diff
0004-bnx2x-update-to-1.52.1-5.patch (108.87 KB, patch)
2009-11-19 15:28 UTC, Stanislaw Gruszka
no flags Details | Diff
0005-bnx2x-update-to-1.52.1-5__v2.patch (108.87 KB, patch)
2009-11-23 09:05 UTC, Stanislaw Gruszka
no flags Details | Diff


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2010:0178 normal SHIPPED_LIVE Important: Red Hat Enterprise Linux 5.5 kernel security and bug fix update 2010-03-29 12:18:21 UTC

Description Eilon Greenstein 2009-08-05 13:33:45 UTC
1.  Feature Overview:
     a. Update bnx2x to 1.50.x version

     b. Feature Description
	This version includes new, more efficient FW, which improves performance. It also includes some minor performance improvements such as separate Rx and Tx MSI-X vectors

2.  Feature Details:
     a. Architectures:
         32-bit x86
         64-bit Intel EM64T/AMD64
         64-bit Itanium2

     b. Upstream acceptance information:
        This version will be submitted to the upstream kernel in the next
couple of weeks (by September 21st)

3. Business Justification:
     a. Why is this feature needed?
	Improved performance

4. Primary contact at Broadcom, email, phone
    Eilon Greenstein
    eilong@broadcom.com
     +972-37552340

Comment 1 Andrius Benokraitis 2009-08-05 14:39:19 UTC
Thanks! Added to the list.

Comment 2 Andrius Benokraitis 2009-08-24 18:04:25 UTC
*** Bug 513232 has been marked as a duplicate of this bug. ***

Comment 3 Andrius Benokraitis 2009-08-24 18:04:43 UTC
*** Bug 511975 has been marked as a duplicate of this bug. ***

Comment 4 Andrius Benokraitis 2009-08-24 18:05:13 UTC
*** Bug 513935 has been marked as a duplicate of this bug. ***

Comment 5 Stanislaw Gruszka 2009-09-29 13:18:57 UTC
*** Bug 516979 has been marked as a duplicate of this bug. ***

Comment 6 Chris Ward 2009-10-13 15:24:47 UTC
@Broadcom and other interested parties,

We need to confirm that there is commitment to test 
for the resolution of this request during the RHEL 5.5 test
phase, if it is accepted into the release. 

Please post a confirmation before Oct 16th, 2009, 
including the contact information for testing engineers.

Comment 7 Tung Nguyen-Hoai 2009-10-13 16:29:09 UTC
10/13/2009 tungn@broadcom.com
Will do core test for this driver when image is ready.

Comment 8 IBM Bug Proxy 2009-10-13 18:31:22 UTC
------- Comment From lcm@us.ibm.com 2009-10-13 14:28 EDT-------
IBM signing up to also provide testing feedback. Please coordinate through Peter Bogdanovic, pbogdano@redhat.com.

Comment 9 Mike Christie 2009-10-14 00:44:17 UTC
Hey Stanislaw,

I had this bugzilla:
https://bugzilla.redhat.com/show_bug.cgi?id=517378
for 5.5 asking to add bnx2x iscsi support. It turns out there is no bnx2i (no iscsi or scsi kernel bits) needed. Broadcom just needs some bnx2x bits.

I wanted to see if you or we or broadcom (for storage drivers we have the vendors make patches but for net do you guys make the patches?) could make sure we get this brought in with the normal update in this bugzilla? Broadcom or I can give you a list of upstream commits, or Broadcom had even made some patches before if you want to go that route.

Also we need this for RHEL6 too. Were you guys going to do any changes to bnx2x for RHEL 6?

Comment 10 Stanislaw Gruszka 2009-10-14 07:13:26 UTC
(In reply to comment #9)
> I wanted to see if you or we or broadcom (for storage drivers we have the
> vendors make patches but for net do you guys make the patches?) 

For networking drivers usually vendors commits upstream and we do backports. 

> could make sure
> we get this brought in with the normal update in this bugzilla? 

No problem.

> Broadcom or I
> can give you a list of upstream commits, or Broadcom had even made some patches
> before if you want to go that route.
 
Yes, you can provide patches, if I did not take them I can always use for compare to my backport. Are there any commits that are not in current 2.6.32 kernel (driver version 1.52.1)? I'm going to do full driver update - take all Broadcom upstream commits.
 
> Also we need this for RHEL6 too. Were you guys going to do any changes to bnx2x
> for RHEL 6?  

https://bugzilla.redhat.com/show_bug.cgi?id=464427

Comment 11 Stanislaw Gruszka 2009-10-14 07:18:40 UTC
Change topic, in upstream we have no version 1.50.x, there is direct update from 1.48 -> 1.52 .

Comment 12 Michael Chan 2009-10-15 18:32:23 UTC
(In reply to comment #10)
> Are there any commits that are not in current 2.6.32
> kernel (driver version 1.52.1)? I'm going to do full driver update - take all
> Broadcom upstream commits.
> 

The iSCSI patches are the same as RHEL6.0.
Please include the following 4 bnx2x patches to support iSCSI:

commit 993ac7b5183f82edc9696cd17faae03523e00e09

    bnx2x: Add main CNIC interface functions.

commit 37b091bacba7bd329eced9a56998b6247da414c4

    bnx2x: Add hw init code to support iSCSI.

commit e665bfda5b8fea586ddd028b26a6e2ed9e987c6b

    bnx2x: Refactor MAC address setup code.

commit 2891290219d8a28a923560d53d24c00fa96fa09f

    bnx2x: Refactor bnx2x_sp_post().

In addition, these cnic patches below to support 10G iSCSI have dependency on
the above bnx2x patches. Please include them as well.  Thanks.

commit c05e85a06e376f6b6d59e71e5333d707e956d78b

    cnic: Need to include net/ip6_checksum.h

commit 71034ba845c9ff219373066f904286c0b7506922

    cnic: Add main functions to support bnx2x devices.

commit e251306556d30c9c678feca60204acaaa0784cbd

    cnic: Add bnx2x data structures.

commit 86b53606ebec06b16be81c30fabdf8decc2be6b2

    cnic: Refactor some code.

commit 6053bbf7bbdbb2c94547f830ad07636c17d7024e

    cnic: Fix NETDEV_UP event processing.

commit 6ef57a0ea77e7bf4123a06da895a0e26312b5737

    cnic: Shutdown iSCSI ring during uio_close.

commit 5e9b2dbfcbc9b180a0064d8a473a4652ee99c9ad

    cnic: Put uio init in separate function.

commit ec0248ea35f6e1fc7426f377a7df071d997bdedd

    cnic: Put rx/tx ring allocation in separate function.

Comment 13 Stanislaw Gruszka 2009-10-16 08:29:27 UTC
(In reply to comment #12)
> In addition, these cnic patches below to support 10G iSCSI have dependency on
> the above bnx2x patches. Please include them as well.  Thanks.

Is this only work that must to be done for bug 517378 ? Otherwise we need to have separate bug entry for that. If so, please create new bug entry (with dependency set to this one) and assign it to me. Thank you.

Comment 14 Michael Chan 2009-10-16 21:34:27 UTC
(In reply to comment #13)
>
> Is this only work that must to be done for bug 517378 ? Otherwise we need to
> have separate bug entry for that. If so, please create new bug entry (with
> dependency set to this one) and assign it to me. Thank you.  

There might be some cnic bug fixes later on.  I'll create a "cnic bug fixes" BZ when necessary.  Thanks.

Comment 15 John Jarvis 2009-10-21 17:55:14 UTC
Please note in https://bugzilla.redhat.com/show_bug.cgi?id=530121 IBM is reporting a problem with bnx2x and their HS22 blades and may require an additional patch or newer driver version to fix this.

Comment 18 John Jarvis 2009-10-23 16:49:12 UTC
This enhancement request was evaluated by the full Red Hat Enterprise Linux 
team for inclusion in a Red Hat Enterprise Linux minor release.   As a 
result of this evaluation, Red Hat has tentatively approved inclusion of 
this feature in the next Red Hat Enterprise Linux Update minor release.   
While it is a goal to include this enhancement in the next minor release 
of Red Hat Enterprise Linux, the enhancement is not yet committed for 
inclusion in the next minor release pending the next phase of actual 
code integration and successful Red Hat and partner testing.

Comment 19 Stanislaw Gruszka 2009-11-04 14:16:56 UTC
*** Bug 531882 has been marked as a duplicate of this bug. ***

Comment 21 Stanislaw Gruszka 2009-11-12 11:30:30 UTC
Created attachment 369186 [details]
0001-bnx2x-update-to-1.52.1.patch

Comment 22 Stanislaw Gruszka 2009-11-12 11:31:33 UTC
Created attachment 369187 [details]
0002-bnx2x-add-firmware-blob-5.0.21.0.patch

Comment 23 Stanislaw Gruszka 2009-11-12 11:33:45 UTC
Patches not include iSCSI commits requested in comment #12. I'm going to work on them separate in 517378 bugzilla entry.

Comment 24 Stanislaw Gruszka 2009-11-12 11:49:11 UTC
Eilon, 

In RHEL5.5 patch I include most commits up to:

    commit c458bc50e31631f7e9333ea6f1832fc54d4e2c1e
    Author: Eilon Greenstein <eilong@broadcom.com>
    Date:   Wed Aug 12 08:24:31 2009 +0000

        bnx2x: update version to 1.52.1

All commits are listed inside patch. I do not backport below three commits,
because in RHEL we have no MDIO support, hope this is ok:

commit 01cd452846c98609dd3efbee0deea050e6706f02
Author: Eilon Greenstein <eilong@broadcom.com>
Date:   Wed Aug 12 08:23:08 2009 +0000

    bnx2x: MDC/MDIO CL45 IOCTLs

commit f57a60256d02daba1316c98da472f02cd98a58d3
Author: Eilon Greenstein <eilong@broadcom.com>
Date:   Wed Aug 12 08:23:11 2009 +0000

    bnx2x: Supporting PHY FW upgrade

commit cdea52128f6099e8f84459823c45790a78264022
Author: Eilon Greenstein <eilong@broadcom.com>
Date:   Wed Aug 12 08:23:14 2009 +0000

    bnx2x: Removing old PHY FW upgrade code


Are we need some newer commits from net-next (other than mentioned in comment
12) ? Or maybe I should do full backport further up to 1.52.1-4 ?

Comment 25 Eilon Greenstein 2009-11-12 11:57:43 UTC
Hi,

The old MDC/MDIO code is no longer used by the utility that upgrades the PHY FW. How about adding the missing code at the end of the bnx2x_compat.h? I will send a patch with this suggestion.

There is still an open issue with the Tx interrupt handling – a patch to move it back to NAPI is being prepared now and should be ready by Sunday. This one should be included as well – I will let you know once it is accepted.

Thanks,
Eilon

Comment 26 Eilon Greenstein 2009-11-12 12:06:01 UTC
Created attachment 369202 [details]
Add requied mdio functionality to bnx2x

Adding the required mdio functionality into bnx2x_compat.h so the fw upgrade utility will be able to upgrade the PHY FW.

Comment 27 Stanislaw Gruszka 2009-11-12 12:25:50 UTC
(In reply to comment #25)

> The old MDC/MDIO code is no longer used by the utility that upgrades the PHY
> FW. How about adding the missing code at the end of the bnx2x_compat.h? I will
> send a patch with this suggestion.
Great.
 
> There is still an open issue with the Tx interrupt handling – a patch to move
> it back to NAPI is being prepared now and should be ready by Sunday. This one
> should be included as well – I will let you know once it is accepted.

Ok, waiting for that fix. What about all other fixes currently in net-next ? I would like to include them in RHEL5, but there is also a FW upgrade change, so I'm not sure. Decision is yours :)

Thanks!

Comment 28 Eilon Greenstein 2009-11-12 14:33:06 UTC
Yes – having all of the net-next changes is preferred.

Thanks,
Eilon

Comment 29 Eilon Greenstein 2009-11-18 18:05:57 UTC
Hi,

Please update everything up to 9a4e328eb2bfa23b160558cff96e17ffa65ea5cf "bnx2x: Don't set netdev->trans_sta" in net-next (please note that this specific change is not applicable to RH5.5).

The driver version is 1.52.1-5 (I'm also updating the BZ summary).

Thanks,
Eilon

Comment 30 Stanislaw Gruszka 2009-11-19 15:25:31 UTC
Created attachment 370367 [details]
0001-bnx2x-update-to-1.52.1.patch

Comment 31 Stanislaw Gruszka 2009-11-19 15:26:29 UTC
Created attachment 370368 [details]
0002-bnx2x-add-firmware-version-5.2.7.0.patch

Comment 32 Stanislaw Gruszka 2009-11-19 15:27:30 UTC
Created attachment 370369 [details]
0003-bnx2x-add-MDIO-support.patch

Comment 33 Stanislaw Gruszka 2009-11-19 15:28:26 UTC
Created attachment 370372 [details]
0004-bnx2x-update-to-1.52.1-5.patch

Comment 34 Stanislaw Gruszka 2009-11-19 18:08:08 UTC
Brew build:
https://brewweb.devel.redhat.com/taskinfo?taskID=2085280

Test packages (i686,x86_64,src) are available for public download here:
http://people.redhat.com/sgruszka/bz515716/

Comment 35 Andrius Benokraitis 2009-11-19 18:28:27 UTC
Broadcom, please test and report back! thanks!

Comment 36 Stanislaw Gruszka 2009-11-23 09:05:07 UTC
Created attachment 373041 [details]
0005-bnx2x-update-to-1.52.1-5__v2.patch

This patch is the same as 0004-bnx2x-update-to-1.52.1-5.patch, but it's rebased  atop Mike Christie patch for bug 516233, which also modifies cnic code.

Comment 37 Don Zickus 2009-11-23 15:32:59 UTC
in kernel-2.6.18-175.el5
You can download this test kernel from http://people.redhat.com/dzickus/el5

Please do NOT transition this bugzilla state to VERIFIED until our QE team
has sent specific instructions indicating when to do so.  However feel free
to provide a comment indicating that this fix has been verified.

Comment 39 Stanislaw Gruszka 2009-11-24 07:27:40 UTC
This patches ware not posted yet and are certainly not included in kernel-2.6.18-175.el5. I posted patch for bug 531882. Moving back to ASSIGNED.

Comment 40 Stanislaw Gruszka 2009-11-26 07:56:46 UTC
I whould like to post patches (In reply to comment #34)
> Test packages (i686,x86_64,src) are available for public download here:
> http://people.redhat.com/sgruszka/bz515716/  

Any partial testing results? I would like to hear everything is fine before positing patches to RKML :-)

Comment 41 Tung Nguyen-Hoai 2009-11-30 16:23:19 UTC
TN tungn@broadcom.com
Tests cases passed: 520( IPV6 stress) 699 ( LED) 874 (Jumbo frame stress)1023 (Generic Bonding) 
Running loadunload. Will post result at the end of today or early tommorrow.

Comment 42 Tung Nguyen-Hoai 2009-12-08 15:33:46 UTC
TN
Test cases( Continued)

Test cases executed: 1368 : loadunload ( Pass) 728 :continuous reboot test (pass)

Comment 43 Ed Narvaez 2009-12-14 21:56:11 UTC
Test Progress Below.  If more information/details are required, please let me konw.  Eddie.

RH5.5 Inbox - Kernel 2.6.18-174
DUT: BCM95771x (common DUT)
Linux - Everest	1.48.107 - 1.52.1

Passed	Failed	N/A	Blocking	Done
7 (33%)	0 (0%)	9 (42%)	0 (0%)		16 of 21 (76%)

Comment 44 Don Zickus 2009-12-15 20:18:30 UTC
in kernel-2.6.18-181.el5
You can download this test kernel from http://people.redhat.com/dzickus/el5

Please update the appropriate value in the Verified field
(cf_verified) to indicate this fix has been successfully
verified. Include a comment with verification details.

Comment 45 Tung Nguyen-Hoai 2009-12-15 22:00:02 UTC
12/15/2009 TN : since this kernel (181) has the same version 1.52.1-5 (bnx2x) as kernel 174 that we have tested for the last 2 weeks, we only do sanity check on the new kernel ( 181). We are running 1368 loadunload only.Please post your concern if there is any. Thanks

Comment 46 Tung Nguyen-Hoai 2009-12-16 16:24:08 UTC
12/16/2009 TN test case 1368 ( loadunload ) ran over night with more than 1000 iterations without any incident. Will update if there is any issue.

Comment 49 Stanislaw Gruszka 2010-01-22 16:06:56 UTC
*** Bug 530121 has been marked as a duplicate of this bug. ***

Comment 50 Gideon Naim 2010-01-24 18:39:16 UTC
In terms of test progress, BRCM PQA is planning on running first pass testing and regression tests by Beta snapshots. Current bnx2x first pass L2 testing (not including iSCSI offload) is at 77% complete.

There is an issue found during automated iSCSI offload protocol testing. This issue is fixed in a newer version of bnx2x datapath fw. There are also additional iSCSI offload datapath fw fixes that were found during testing during our out of box testing on RH5.4. A separate bugzilla will be opened for these issues.

Comment 51 Ryan Lerch 2010-01-28 02:48:01 UTC
Technical note added. If any revisions are required, please edit the "Technical Notes" field
accordingly. All revisions will be proofread by the Engineering Content Services team.

New Contents:
= Broadcom Everest network devices =

The bnx2x driver for Broadcom Everest network devices has been updated to version 1.52.1-5.(BZ#515716, BZ#522600)

Comment 52 Linda Wang 2010-02-03 20:44:51 UTC
*** Bug 516090 has been marked as a duplicate of this bug. ***

Comment 53 Gideon Naim 2010-02-16 05:04:43 UTC
Test progress update - BRCM PQA current bnx2x first pass L2 testing
(not including iSCSI offload) is at 90% complete.

Comment 54 IBM Bug Proxy 2010-02-17 22:15:18 UTC
------- Comment From coschult@us.ibm.com 2010-02-17 16:52 EDT-------
Verified Beta 1 using Broadcom 57710 adapter. Driver present after
booting and card detected and configured successfully. Tested using netperf
(np3d test suite) on local network. All tests passed.

Comment 55 Issue Tracker 2010-02-19 19:49:53 UTC
Event posted on 02-19-2010 11:07am EST by Glen Johnson

------- Comment From linuxram@us.ibm.com 2010-02-19 10:59 EDT-------
This issue seems to be resolved on 5.5. We never encountered this problem
in our 5.5 testing. Earlier we used to see this issue once in at least 3-4
reboots. Not anymore.


This event sent from IssueTracker by jkachuck 
 issue 355557

Comment 56 Thomas Chenault 2010-02-20 04:22:09 UTC
I have tested bnx2x 1.52.1-5 as provided in kernel 2.6.18-186.el5 x86_64 on a variety of Broadcom 57710/57711 based network adapters. I have not encountered any problems.

Comment 58 Gideon Naim 2010-02-25 03:40:18 UTC
Hi,

Broadcom PQA has moved to test 1.52.1-6 with the new updated fw.

During the testing a new issue was found that during increasing netperf stress, the system scrolled message:
bnx2x_start_xmit: 11208 Eth1 BUG! tx ring full when queue awake.
A new bugzilla opened -   Bug 567979 - bnx2x: net device is in XON state while the Tx ring is full 


Thanks,
Gideon

Comment 61 errata-xmlrpc 2010-03-30 07:26:58 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2010-0178.html


Note You need to log in before you can comment on or make changes to this bug.